#
# api: streamtuner2
# title: Bieber
# description: Bieber channel
#
# Test plugin for the compound search feature.
#



from channels import *

# Google Stations is actually now DMOZ Stations
class bieber(ChannelPlugin):

    # description
    title = "Bieber"
    module = "bieber"
    homepage = "http://www.justinbiebermusic.com/"
    version = 1.0
    
    # config data
    config = [
        {"name": "bieber_filter", "type": "text", "value":"BIEBERBLAST", "description":"So and so."},
    ]
    

    # category map
    categories = ['the Biebs']
    default = 'the Biebs'
    current = 'the Biebs'




    # refresh category list
    def update_categories(self):
    
        pass
        # let's keep it at that, shall we?



    # download links from dmoz listing
    def update_streams(self, cat, force=0):

        # result list
        entries = []
        
        # kill our current list, so we won't find our own entries
        self.streams = {}
        
        # swamp through all plugins
        for name,p in self.parent.channels.iteritems():
            #print "bieberquest: channel", name

            # subcategories in plugins        
            for cat,stations in p.streams.iteritems():
                #print "   bq cat", cat
            
                # station entries
                for row in stations:

                    # collect text fields, do some typecasting, lowercasing
                    text = "|".join([str(e) for e in row.values()])
                    text = text.lower()

                    # compare
                    if text.find("bieb") >= 0:
                    
                        # add to result list
                        row["genre"] = name + ": " + row.get("genre", "")
                        entries.append(row)

        # final list
        return entries
        


