#
# api: streamtuner2
# title: MyOggRadio channel plugin
# description: open source internet radio directory MyOggRadio
# version: 0.3
# config:
#    <var name="myoggradio_login" type="text" value="user:password" description="login account for myoggradio service" />
#
# Preliminary plugin.
# Project partnership.
# More features are going to come.
# Especially uploading bookmarks.
#



from channels import *
from config import conf

import re
import pson
from StringIO import StringIO



# 
class myoggradio(ChannelPlugin):

    # description
    title = "MyOggRadio"
    module = "myoggradio"
    homepage = "http://ehm.homelinux.org/MyOggRadio/"
    version = 0.3
    listformat = "url/direct"
    
    # config data
    config = [
        {"name":"myoggradio_login", "type":"text", "value":"user:password", "description":"Account for storing personal favourites."},
    ]
    

    # category map
    categories = ['common', 'personal']
    default = 'common'
    current = 'common'




    # this is simple, there are no categories
    def update_categories(self):
        pass



    # download links from dmoz listing
    def update_streams(self, cat, force=0):

        # result list
        entries = []
        
        # common
        if (cat == "common"):
            # fetch
            data = http.get(self.homepage + "common.json")
            entries = pson.load(StringIO(data))
            
        # bookmarks
        elif (cat == "personal") and self.user_pw():
            data = http.get(self.homepage + "favoriten.json?user=" + self.user_pw()[0])
            print "DATA=", data
            entries = pson.load(StringIO(data))
        
        # unknown
        else:
            self.parent.status("Unknown category")
            pass

        # augment result list
        for i,e in enumerate(entries):
            entries[i]["homepage"] = self.homepage + "c_common_details.jsp?url="  + e["url"]
        # send back
        return entries
        


    # upload bookmarks
    def send_bookmarks(self, entries=[]):
    
        for e in (entries if entries else parent.bookmarks.streams["favourite"]):
            submit = {
                "url": e["url"],
                "bemerkung": e["title"],
                "typ": e["format"][6:],
                "eintragen": "eintragen",
            }
            http.ajax(self.homepage + "c_neu.jsp", data)
            # just push data in, like the form does
            
            
    # authenticate against MyOggRadio
    def login(self):

        login = self.user_pw()    
        if login:
            data = dict(zip(["benutzer", "passwort"], login))
            http.ajax(self.homepage + "c_login.jsp", data)
            # let's hope the JSESSIONID cookie is kept


    # returns login (user,pw)
    def user_pw(self):
        if conf.myoggradio_login != "user:password":
            return conf.myoggradio_login.split(":")
        else: pass
        




